VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CKeys"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'********************************************
'* CKeys.cls                                *
'*                                          *
'* Saves the keys for each connection       *
'* in a collection                          *
'*                                          *
'* You can use this code for free at your   *
'* own risk; the author doesn't correspond  *
'* to any damages created by this code.     *
'*                                          *
'* (C) 2003 by Claus von der Burchard       *
'* for AVB Messenger                        *
'* contact: claus@cvdb.de                   *
'*                                          *
'* Last Change: 20-Feb-2004                 *
'********************************************
Option Explicit

Dim colKeys     As Collection

Public Function AddKey(strIP As String, ChatNick As String, strKey As String) As Boolean
    On Error GoTo Errhandler
    'strIP = vbNullString
    Dim strKeyName  As String
    
    Call DeleteKey(strIP, ChatNick, True)
    strKeyName = LCase$("k" & strIP & "\" & ChatNick)
    colKeys.Add strKey, strKeyName
    AddKey = True
    
    Exit Function
Errhandler:
End Function

Public Function DeleteKey(strIP As String, ChatNick As String, Optional OnlyDelete As Boolean = False) As Boolean
    On Error GoTo Errhandler
    Dim strKeyName  As String
    'strIP = vbNullString
    strKeyName = LCase$("k" & strIP & "\" & ChatNick)
    colKeys.Remove (strKeyName)
    
    If Not OnlyDelete Then _
        Call MyConnection.clsWinSock_SendDatas( _
          Encoder.GetCommandLine("DELETE_KEY", modClient.LocalUser.cpUsername), _
          strIP, _
          ChatNick _
        )
    
    DeleteKey = True
    On Error GoTo 0
    Exit Function
    
Errhandler:
End Function

Public Function FindKey(strIP As String, ChatNick As String) As String
    On Error Resume Next
    'strIP = vbNullString
    Dim strKeyName  As String
    strKeyName = LCase$("k" & strIP & "\" & ChatNick)
    FindKey = colKeys.Item(strKeyName)
    
    On Error GoTo 0
End Function

Public Sub EraseKeys()
    Set colKeys = Nothing
    Set colKeys = New Collection
End Sub

Private Sub Class_Initialize()
    Set colKeys = New Collection
End Sub

Private Sub Class_Terminate()
    Set colKeys = Nothing
End Sub
