Attribute VB_Name = "modStyleSheet"
Option Explicit

Public Enum TokenType
    ID
    NUM
    STRVAL
    OBR
    CBR
    DELIM
    DEF
    EOF
End Enum

' VB daran hindern die Gro-/Kleinschreibung zu ndern
' "As Long" damit der VB6 Code Advisor nix zu meckern hat
    
    #If False Then
        Public ID As Long
        Public NUM As Long
        Public STRVAL As Long
        Public OBR As Long
        Public CBR As Long
        Public DELIM As Long
        Public DEF As Long
        Public EOF As Long
    #End If
    
'----------------------------------------------------

Public TokenVal As String
'----------------------------------------------------

Public Function Str2Col(Value As String) As OLE_COLOR
    If LeftB$(Value, 2) = "#" Then
        Select Case Len(Value)
            Case 4
                Str2Col = _
                    Val( _
                        "&H" & _
                        Mid$(Value, 4, 1) & "0" & _
                        Mid$(Value, 3, 1) & "0" & _
                        Mid$(Value, 2, 1) & "0" _
                    )
            Case 7
                Str2Col = _
                    Val( _
                        "&H" & _
                        Mid$(Value, 6, 2) & _
                        Mid$(Value, 4, 2) & _
                        Mid$(Value, 2, 2) _
                    )
            Case Else
        End Select
    Else
        Select Case LCase$(Value)
            Case "black"
                Str2Col = vbBlack
            Case "white"
                Str2Col = vbWhite
            Case "red"
                Str2Col = vbRed
            Case "green"
                Str2Col = vbGreen
            Case "blue"
                Str2Col = vbBlue
            Case "yellow"
                Str2Col = vbYellow
            Case "darkred"
                Str2Col = RGB(128, 0, 0)
            Case "darkblue"
                Str2Col = RGB(0, 0, 128)
            Case "darkgreen"
                Str2Col = RGB(0, 128, 0)
            Case "gold", "olive"
                Str2Col = RGB(128, 128, 0)
            Case "silver"
                Str2Col = &H808080
            Case "gray", "grey"
                Str2Col = &HC8C8C8
        End Select
    End If
End Function
