Attribute VB_Name = "modMain"
Option Explicit

Public Declare Function SendMessage Lib "user32.dll" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByRef lParam As Any) As Long
Public Const WM_SETFOCUS = &H7
Public Const Cstr_Version = "0.9.0"

Public Declare Function FlashWindow Lib "user32" (ByVal hwnd As Long, ByVal bInvert As Long) As Long
Public Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Public Declare Function GetActiveWindow Lib "user32" () As Long
Public Declare Function GetCaretBlinkTime Lib "user32.dll" () As Long

Public Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long

Public Declare Function MessageBox Lib "user32" Alias "MessageBoxA" (ByVal hwnd As Long, ByVal lpText As String, ByVal lpCaption As String, ByVal wType As Long) As Long

Private Declare Function FindWindow Lib "user32.dll" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long

Public Declare Function LoadImage Lib "user32.dll" Alias "LoadImageA" (ByVal hInst As Long, ByVal lpsz As String, ByVal un1 As Long, ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As Long
Public Declare Function LoadIcon Lib "user32.dll" Alias "LoadIconA" (ByVal hInstance As Long, ByVal lpIconName As String) As Long
Public Declare Function DestroyIcon Lib "user32.dll" (ByVal hIcon As Long) As Long

Public Declare Sub OutputDebugString Lib "kernel32.dll" Alias "OutputDebugStringA" (ByVal lpOutputString As String)

Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2
Public Const SWP_NOSIZE = &H1
Public Const SWP_NOMOVE = &H2
Public Const SWP_HIDEWINDOW As Long = &H80

Public strNewConnectionIP       As String
Public strNewConnectionUser     As String
Public strRoutingConnectionIP   As String
Public strRoutingConnectionUser As String
Public m_RefreshInt             As Long
Public m_SessionID              As String

'Twips Werte cachen -> 4KB weniger Programmcode
'und schnellere Ausfhrung
Public m_lngTwipsPerPixelX As Long
Public m_lngTwipsPerPixelY As Long

Public SystemTray               As clsSystemTray

Sub Main()
    Dim strUsername As String
    Dim strPassword As String
    Dim siMainLeft As Single
    Dim siMailTop As Single
    Dim siMainWidth As Single
    Dim siMainHeigth As Single
    
    m_lngTwipsPerPixelX = Screen.TwipsPerPixelX
    m_lngTwipsPerPixelY = Screen.TwipsPerPixelY
    
    'AVBM nur einmal starten
    If App.PrevInstance Then
        Dim hWndPrevInstance        As Long
        
        hWndPrevInstance = FindWindow(vbNullString, "ActiveVB Messenger")
        If hWndPrevInstance <> 0 Then Call SetForegroundWindow(hWndPrevInstance)
        Exit Sub
    End If
    
    ' Settings initialisieren
    ' Wichtig!!!!!! Das ist das erste was gemacht werden mu,
    ' da sonst die Einstellungen nicht abgefragt werden knnen
    ' Achtung: Noch davor Base64 initialisieren, sonst funktionieren
    ' die Settings nmlich nicht ;) ...
    Call InitBase64(Base64)
    LoadSettings ' App.Path & "\avbm.ini" ' <-- OBSOLET! CIni bestimmt den Pfad alleine!
                                          ' Anmerkung v. KonRad am 11/06/2004 um 16:56
    
    'Settings fr die Socket
    m_MAX_SOCKET = CLng(Val(modSettings.GetSetting("Connection", "Max")))
    m_SOCKET_DEFAULT_PORT = SOCKET_DEFAULT_PORT
    m_ConnectionQuality = CLng(Val(modSettings.GetSetting("Connection", "BandWidthUL")) * 117.1875)
    m_ProxyEnabled = CBool(modSettings.GetSetting("Proxy", "Enabled"))
    m_ProxyPort = CLng(Val(modSettings.GetSetting("Proxy", "Port")))
    m_ProxyServer = modSettings.GetSetting("Proxy", "Server")
    m_ProxyOverride = modSettings.GetSetting("Proxy", "Override")
    m_SocketLogLevel = SOCKETLOG_WARNING '_EX 'and Higher
    
    If m_ProxyEnabled = True And Len(m_ProxyServer) = 0 Or m_ProxyPort = 0 Then
        'Error Proxysettings
       MsgBox "Die Proxyeinstellungen weisen Fehler auf, sie werden ignoriert!", vbCritical Or vbSystemModal, "Einstellungsfehler"
       m_ProxyEnabled = False
    End If
    If m_ConnectionQuality < Modem Then
        'Connectionquality wurde schadhaft gepatched
        m_ConnectionQuality = ISDN
        Call modSettings.WriteSetting("Connection", "BandWidthUL", ISDN)
    End If
    If m_MAX_SOCKET < MAX_SOCKET Then
        m_MAX_SOCKET = MAX_SOCKET
        Call modSettings.WriteSetting("Connection", "Max", MAX_SOCKET)
    End If
    
    Set dlgMain.Connection = New clsWinSock
    Set MyConnection = dlgMain.Connection
    Set dlgMain.CreateConnection = New cCreateConnection
    Set MyCreateConnection = dlgMain.CreateConnection
    Set Encoder = New CEncoding
    Set Parser = New CParser
    Set ChatWindows = New Collection
    
    Set dlgMain.ClientManagement = New clsClient
    Call modClient.Init
    Call modChat.InitSmilies
    
    Call modChat.SetColors
        
    'dlgMain.WindowState = CLng(modSettings.GetSetting("WindowMode", "State"))
    ' Change by Kai 19.10.2005
    siMainLeft = CSng(modSettings.GetSetting("Position", "Left"))
    siMailTop = CSng(modSettings.GetSetting("Position", "Top"))
    siMainHeigth = CSng(modSettings.GetSetting("Position", "Height"))
    siMainWidth = CSng(modSettings.GetSetting("Position", "Width"))
    
    If siMainWidth < 2700 Then siMainWidth = 2701
    If siMainHeigth < 5000 Then siMainHeigth = 5001
    If Screen.Width < siMainLeft - siMainWidth Then siMainLeft = Screen.Width - siMainWidth
    If Screen.Height < siMailTop + (siMainHeigth / 8) Then siMailTop = Screen.Height - siMainHeigth
    If siMainLeft < -(siMainWidth / 2) Then siMainLeft = Screen.Width - siMainWidth
    If siMailTop < 0 Then siMailTop = Screen.Height - siMainHeigth
    
    dlgMain.Width = siMainWidth: dlgMain.Height = siMainHeigth
    dlgMain.Left = siMainLeft: dlgMain.Top = siMailTop
    'Change End
    ' krml06/03/2005
    If Not CBool(CLng(modSettings.GetSetting("Startup", "Minimized"))) Then
        dlgMain.Show
    End If
    
    'Systemtray initialisieren
    Set SystemTray = New clsSystemTray
    Call SystemTray.InitSystray(dlgMain.imlBuddyIcons.ListImages("Online" & IIf(SystemTray.OSBuild > 2195, vbNullString, "16")).ExtractIcon.Handle, dlgMain.picTray.hwnd)

    ' automatisch anmelden?
    If CBool(modSettings.GetSetting("User", "LogIn")) Then
        strUsername = modSettings.GetSetting("User", "Name")
        strPassword = modSettings.GetCryptedSetting("User", "Password")
        If LenB(strUsername) Then
            If Connect(strUsername, strPassword) Then
               Call dlgMain.Connection.clsWinsock_StartListener
               Call dlgMain.SetToolbarButtons
            Else
               'MsgBox "Fehler beim Einloggen.", vbOKOnly Or vbCritical, "Fehler"
            End If
        Else
            MsgBox "Kein Benutzername zum Einloggen angegeben.", vbOKOnly Or vbCritical, "Fehler"
        End If
    End If
    
End Sub

Public Sub QuitApplication()
   On Error Resume Next
   Dim curForm As Form

   Call dlgMain.Hide
   Call SystemTray.DeleteSystray(dlgMain.picTray.hwnd)

   For Each curForm In Forms
    Debug.Print curForm.name
      Unload curForm
      Set curForm = Nothing
   Next curForm

   'End

End Sub

' --------------------------------------------------- '

'Public Sub FlashForm(hwnd As Long, TimerObject As Timer, Flashing As Boolean, ByRef FlashState As Boolean)
Public Sub FlashForm(hwnd As Long, TimerObject As Timer, Flashing As Boolean)
   If Flashing Then
      TimerObject.Interval = GetCaretBlinkTime() * 2
'      If FlashState Then
        Call FlashWindow(hwnd, 1)
'        FlashState = Not FlashState
'      Else
      '  Call FlashWindow(hwnd, True)
      '  FlashState = True
'      End If
      TimerObject.Enabled = True
   Else 'If TimerObject.Enabled Then
      TimerObject.Enabled = False
      'If FlashState Then Call FlashWindow(hwnd, 1)
   End If
End Sub

Public Function IsFormLoaded(ByRef vData As Variant) As Boolean
   Dim objForm As Form
   
   IsFormLoaded = False
   
   If (VarType(vData) = vbString) Then
      For Each objForm In VB.Forms
         If objForm.name = vData Then
            IsFormLoaded = True
            Exit Function
         End If
      Next objForm
   
   Else
      If (VarType(vData) = vbObject) Then
         IsFormLoaded = IsFormLoaded(TypeName$(vData))
      End If
   
   End If

End Function

Public Sub ExecuteParameters(ParamValue As String, ParamType As String)
Select Case LCase$(ParamType)
    Case "refresh"
        m_RefreshInt = Val(ParamValue)
    Case "sessid"
        m_SessionID = ParamValue
    Case Else
End Select
End Sub
