VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CStringBuilder"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False


'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !

'****************************************************
'* CStringBuilder.cls                               *
'* allows VERY fast string concatenation            *
'* Programmed: Konrad Rudolph (Mad Rat Pro.)        *
'* Last Change: 10.09.2003 11:49                    *
'* Version: 1.0.0                                   *
'****************************************************
Option Explicit

Private m_sBuffer   As String
Private m_lLen      As Long
Private m_lOffset   As Long
'----------------------------------------------------

Private Sub Class_Initialize()
    m_lLen = 1000
    m_lOffset = 1
    
    m_sBuffer = Space$(m_lLen \ 2)
End Sub
'----------------------------------------------------

Public Property Get Length() As Long
    Length = (m_lOffset - 1) \ 2
End Property

Public Function ToString() As String
    ToString = MidB$(m_sBuffer, 1, m_lOffset - 1)
End Function

Public Sub CreateBuffer(Size As Long)
    m_lLen = Size * 2
    m_lOffset = 1
    
    m_sBuffer = Space$(Size)
End Sub

Public Sub Append(Value As String)
    Dim NewOffset   As Long
    
    NewOffset = m_lOffset + LenB(Value)
    
    If NewOffset > m_lLen Then
        m_sBuffer = m_sBuffer & Space$(NewOffset)
        m_lLen = LenB(m_sBuffer)
    End If
    
    MidB$(m_sBuffer, m_lOffset) = Value
    m_lOffset = NewOffset
End Sub

Public Sub AppendLine(Optional Value As String = "")
    Call Me.Append(Value)
    Call Me.Append(vbNewLine)
End Sub
